'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.RestfulAPI = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

//methods
var GET = 'GET';
var POST = 'POST';
var PUT = 'PUT';
var DELETE = 'DELETE';

// content-types
var dataType = 'json';
var APPLICATION_JSON = 'application/json';
var MULTIPART_FORM_DATA = 'multipart/form-data';

var RestfulAPI = exports.RestfulAPI = function () {
	function RestfulAPI(options) {
		_classCallCheck(this, RestfulAPI);

		if (options) {
			this.errorResponseHandler = options.errorResponseHandler;
		}
	}

	_createClass(RestfulAPI, [{
		key: 'applySecurity',
		value: function applySecurity(options, data) {
			/* hook method */
		}
	}, {
		key: 'handleRequest',
		value: function handleRequest(baseUrl, type) {
			var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];
			var data = arguments[3];


			var params = { type: type, dataType: dataType };
			params.url = baseUrl;

			if (type === POST || type === PUT) {
				if (data instanceof FormData) {
					params.contentType = MULTIPART_FORM_DATA;
					params.data = data;
				} else {
					params.contentType = APPLICATION_JSON;
					params.data = JSON.stringify(data);
				}
			}

			if (params.type !== GET) {
				params.processData = false;
			}

			if (this.errorResponseHandler) {
				options.error = this.errorResponseHandler;
			}

			this.applySecurity(options, data);

			return _jquery2.default.ajax(_extends({}, params, options));
		}
	}, {
		key: 'fetch',
		value: function fetch(url, options) {
			return this.handleRequest(url, GET, options);
		}
	}, {
		key: 'get',
		value: function get(url, options) {
			return this.fetch(url, options);
		}
	}, {
		key: 'post',
		value: function post(url, data, options) {
			return this.handleRequest(url, POST, options, data);
		}
	}, {
		key: 'put',
		value: function put(url, data, options) {
			return this.handleRequest(url, PUT, options, data);
		}
	}, {
		key: 'destroy',
		value: function destroy(url, options) {
			return this.handleRequest(url, DELETE, options);
		}
	}]);

	return RestfulAPI;
}();

var instance = new RestfulAPI();

exports.default = instance;